Index: XIOS3/trunk/src/config/domain_attribute.conf
===================================================================
--- XIOS3/trunk/src/config/domain_attribute.conf	(revision 2498)
+++ XIOS3/trunk/src/config/domain_attribute.conf	(revision 2507)
@@ -62,4 +62,6 @@
 
 DECLARE_ARRAY(double, 2, area, false)
+DECLARE_ARRAY(double, 2, area_2d, false)
+DECLARE_ARRAY(double, 1, area_1d, false)
 DECLARE_ATTRIBUTE(double, radius)
 
Index: XIOS3/trunk/src/config/node_type.conf
===================================================================
--- XIOS3/trunk/src/config/node_type.conf	(revision 2498)
+++ XIOS3/trunk/src/config/node_type.conf	(revision 2507)
@@ -132,4 +132,16 @@
 #endif //__XIOS_CServiceNode__
 
+#ifdef __XIOS_CRedistributeDomain__
+   DECLARE_NODE(RedistributeDomain, redistribute_domain)
+#endif //__XIOS_CRedistributeDomain__
+
+#ifdef __XIOS_CRedistributeAxis__
+   DECLARE_NODE(RedistributeAxis, redistribute_axis)
+#endif //__XIOS_CRedistributeAxis__
+
+#ifdef __XIOS_CRedistributeScalar__
+   DECLARE_NODE(RedistributeScalar, redistribute_scalar)
+#endif //__XIOS_CRedistributeScalar__
+
 #ifdef __XIOS_CContext__
    DECLARE_NODE_PAR(Context, context)
Index: XIOS3/trunk/src/config/redistribute_axis_attribute.conf
===================================================================
--- XIOS3/trunk/src/config/redistribute_axis_attribute.conf	(revision 2507)
+++ XIOS3/trunk/src/config/redistribute_axis_attribute.conf	(revision 2507)
@@ -0,0 +1,3 @@
+DECLARE_ARRAY(int,1, index, false)
+DECLARE_ARRAY(bool, 1 , mask, false)
+DECLARE_ENUM5(type, index, root, bands, column, full)
Index: XIOS3/trunk/src/config/redistribute_domain_attribute.conf
===================================================================
--- XIOS3/trunk/src/config/redistribute_domain_attribute.conf	(revision 2507)
+++ XIOS3/trunk/src/config/redistribute_domain_attribute.conf	(revision 2507)
@@ -0,0 +1,3 @@
+DECLARE_ARRAY(int,1, index, false)
+DECLARE_ARRAY(bool, 1 , mask, false)
+DECLARE_ENUM5(type, index, root, bands, column, full)
Index: XIOS3/trunk/src/config/redistribute_scalar_attribute.conf
===================================================================
--- XIOS3/trunk/src/config/redistribute_scalar_attribute.conf	(revision 2507)
+++ XIOS3/trunk/src/config/redistribute_scalar_attribute.conf	(revision 2507)
@@ -0,0 +1,3 @@
+DECLARE_ARRAY(int,1, index, false)
+DECLARE_ARRAY(bool, 1 , mask, false)
+DECLARE_ENUM5(type, index, root, bands, column, full)
Index: XIOS3/trunk/src/distribution/grid_remote_connector.cpp
===================================================================
--- XIOS3/trunk/src/distribution/grid_remote_connector.cpp	(revision 2498)
+++ XIOS3/trunk/src/distribution/grid_remote_connector.cpp	(revision 2507)
@@ -99,7 +99,8 @@
       size_t globalIndexSize = globalIndex.numElements() ;
       
-      size_t allEqual ;
-      MPI_Allreduce(&globalIndexSize, &allEqual, 1, MPI_SIZE_T, MPI_BXOR, localComm_) ;
-      if (allEqual!=0) 
+      size_t minVal,maxVal ;
+      MPI_Allreduce(&globalIndexSize, &minVal, 1, MPI_SIZE_T, MPI_MIN, localComm_) ;
+      MPI_Allreduce(&globalIndexSize, &maxVal, 1, MPI_SIZE_T, MPI_MAX, localComm_) ;
+      if (minVal!=maxVal) 
       {
         isSrcViewDistributed_[i]=true ;
@@ -110,6 +111,7 @@
       size_t hashValue=0 ;
       for(size_t ind=0;ind<globalIndexSize;ind++) hashValue += hashGlobalIndex(globalIndex(ind)) ;
-      MPI_Allreduce(&hashValue, &allEqual, 1, MPI_SIZE_T, MPI_BXOR, localComm_) ;
-      if (allEqual!=0) isSrcViewDistributed_[i]=true ;
+      MPI_Allreduce(&hashValue, &minVal, 1, MPI_SIZE_T, MPI_MIN, localComm_) ;
+      MPI_Allreduce(&hashValue, &maxVal, 1, MPI_SIZE_T, MPI_MAX, localComm_) ;
+      if (minVal!=maxVal) isSrcViewDistributed_[i]=true ;
       else isSrcViewDistributed_[i]=false ;
     }
Index: XIOS3/trunk/src/distribution/transform_connector.hpp
===================================================================
--- XIOS3/trunk/src/distribution/transform_connector.hpp	(revision 2498)
+++ XIOS3/trunk/src/distribution/transform_connector.hpp	(revision 2507)
@@ -32,6 +32,8 @@
    
     public:
+      
+
       template<typename T> 
-      void transfer(int repeat, int sizeT, const CArray<T,1>& dataIn, CArray<T,1>& dataOut)
+      void transfer(int repeat, int sizeT, const CArray<T,1>& dataIn, CArray<T,1>& dataOut, bool useMissingValue, T missingValue)
       {
         map<int,CArray<T,1>> tmpArrayIn ;
@@ -58,6 +60,21 @@
         MPI_Waitall(requests.size(), requests.data(),status.data()) ;
         
-        const double nanValue = std::numeric_limits<double>::quiet_NaN();
-        gathererConnector_->transfer(repeat, sizeT , tmpArrayOut, dataOut, nanValue) ;
+        if (useMissingValue) gathererConnector_->transfer(repeat, sizeT , tmpArrayOut, dataOut, missingValue) ;
+        else gathererConnector_->transfer(repeat, sizeT , tmpArrayOut, dataOut) ;
+ //       const double nanValue = std::numeric_limits<double>::quiet_NaN();
+ //       gathererConnector_->transfer(repeat, sizeT , tmpArrayOut, dataOut, nanValue) ;
+      }
+
+      template<typename T> 
+      void transfer(int repeat, int sizeT, const CArray<T,1>& dataIn, CArray<T,1>& dataOut)
+      {
+        T missingValue ;
+        transfer(1, sizeT, dataIn, dataOut, false, missingValue) ;
+      }
+
+      template<typename T> 
+      void transfer(int repeat, int sizeT, const CArray<T,1>& dataIn, CArray<T,1>& dataOut, T missingValue)
+      {
+        transfer(1, sizeT, dataIn, dataOut, true, missingValue) ;
       }
 
@@ -66,4 +83,10 @@
       {
         transfer(1, sizeT, dataIn, dataOut) ;
+      }
+
+      template<typename T> 
+      void transfer(int sizeT, const CArray<T,1>& dataIn, CArray<T,1>& dataOut, T missingValue)
+      {
+        transfer(1, sizeT, dataIn, dataOut, missingValue) ;
       }
    
@@ -74,4 +97,10 @@
       }
 
+      template<typename T> 
+      void transfer(const CArray<T,1>& dataIn, CArray<T,1>& dataOut, T missingValue)
+      {
+        transfer(1, 1, dataIn, dataOut, missingValue) ;
+      }
+
   };
 
Index: XIOS3/trunk/src/filter/client_online_reader_filter.cpp
===================================================================
--- XIOS3/trunk/src/filter/client_online_reader_filter.cpp	(revision 2507)
+++ XIOS3/trunk/src/filter/client_online_reader_filter.cpp	(revision 2507)
@@ -0,0 +1,100 @@
+#include "client_from_server_source_filter.hpp"
+#include "grid.hpp"
+#include "field.hpp"
+#include "file.hpp"
+#include "exception.hpp"
+#include "calendar_util.hpp"
+#include "context.hpp"
+#include "event_client.hpp"
+#include "timer.hpp"
+#include "tracer.hpp"
+#include <limits> 
+#include "workflow_graph.hpp"
+#include "grid_redistribute_filter_in.hpp"
+
+namespace xios
+{
+  CClientOnlineReaderFilter::CClientOnlineReaderFilter(CGarbageCollector& gc, CField* fieldOut)
+    : CFilter(gc, 1, this)
+  {
+    CContext* context = CContext::getCurrent();
+ 
+    CField* fieldIn ;
+    redistributeFilter_ = std::shared_ptr<CGridRedistributeFilterIn>(new CGridRedistributeFilterIn(gc, fieldOut, fieldIn));
+    fieldIn->setFileIn(fieldOut->getFileIn());
+    fieldOut->getFileIn()->replaceEnabledFields(fieldOut, fieldIn) ;
+    fileReaderSourceFilter_ = std::shared_ptr<CFileReaderSourceFilter>(new CFileReaderSourceFilter(gc, fieldIn));
+    fieldIn->solveServerOperation() ; // might not be called, create a new time functor.... find a better solution later
+
+// connect filters
+    fileReaderSourceFilter_->connectOutput(redistributeFilter_, 0);
+
+    field_ = fieldIn ;
+    freqOp_ = fieldOut->getRelFile()->output_freq ;
+    offset_ = fieldOut->freq_offset ;
+  }
+
+
+  void CClientOnlineReaderFilter::connectOutput(std::shared_ptr<CInputPin> inputPin, size_t inputSlot)
+  {
+    // connection to redistributeFilter cannot be done at construction time due to shared_from_this(), doing it now
+    redistributeFilter_->connectOutput(shared_from_this(), 0);
+    CFilter::connectOutput(inputPin,inputSlot) ;
+  }
+
+  CDataPacketPtr CClientOnlineReaderFilter::apply(std::vector<CDataPacketPtr> data)
+  {
+    const CDate& currentDate = CContext::getCurrent()->getCalendar()->getCurrentDate();
+    
+    data[0]->date = currentDate ;
+    data[0]->timestamp = currentDate ;
+
+    if (data[0]->status == CDataPacket::END_OF_STREAM)
+    {  
+      isEOF_=true ;
+      dateEOF_ = data[0]->date ;
+    }
+    return data[0];
+  }
+
+  bool CClientOnlineReaderFilter::sendReadDataRequest(const CDate& tsDataRequested)
+  {
+    CContext* context = CContext::getCurrent();
+    const CDate& currentDate = CContext::getCurrent()->getCalendar()->getCurrentDate();
+    CDate checkDate ;
+    if (isFirstDataSent_) checkDate = lastDateReceived_ + freqOp_ ;
+    else checkDate = context->getCalendar()->getInitDate() + offset_ ;
+    
+    if (currentDate >= checkDate)  
+    {
+      fileReaderSourceFilter_->streamData();
+      if (isFirstDataSent_)  lastDateReceived_ = lastDateReceived_ + freqOp_ ;
+      else lastDateReceived_ = context->getCalendar()->getInitDate() + offset_ ;
+      isFirstDataSent_ = true ;
+    }
+    return !isEOF_;
+  }
+
+  bool CClientOnlineReaderFilter::sendReadDataRequestIfNeeded(void)
+  TRY
+  {
+    const CDate& currentDate = CContext::getCurrent()->getCalendar()->getCurrentDate();
+    return sendReadDataRequest(currentDate);
+  }
+  CATCH
+
+  void CClientOnlineReaderFilter::checkForLateData(void)
+  TRY
+  {
+    return ;
+  }
+  CATCH
+
+  
+  bool CClientOnlineReaderFilter::isDataLate(void)
+  {
+    return false ; 
+  }
+
+
+} // namespace xios
Index: XIOS3/trunk/src/filter/client_online_reader_filter.hpp
===================================================================
--- XIOS3/trunk/src/filter/client_online_reader_filter.hpp	(revision 2507)
+++ XIOS3/trunk/src/filter/client_online_reader_filter.hpp	(revision 2507)
@@ -0,0 +1,64 @@
+#ifndef __XIOS_CLIENT_ONLINE_READER_FILTER__
+#define __XIOS_CLIENT_ONLINE_READER_FILTER__
+
+#include <map>
+
+#include "output_pin.hpp"
+#include "event_server.hpp"
+#include "context_client.hpp"
+#include "calendar_util.hpp"
+
+
+namespace xios
+{
+  class CGrid;
+  class CField;
+  class CGridRedistributeFilterIn ;
+  class CFileReaderSourceFilter ;
+
+  /*!
+   * A source filter is the entry point of the data in the graph of filters.
+   */
+  class CClientOnlineReaderFilter : public CFilter, public IFilterEngine, public std::enable_shared_from_this<CClientOnlineReaderFilter>
+  {
+    public:
+      /*!
+       * Constructs a source filter accepting data attached to the specified grid.
+       *
+       * \param gc the garbage collector associated with this filter
+       * \param field associated to the filter
+       */
+      CClientOnlineReaderFilter(CGarbageCollector& gc, CField* field);
+      virtual void connectOutput(std::shared_ptr<CInputPin> inputPin, size_t inputSlot) ;
+      /*!
+       * Transforms the data received from the model into a packet and send it
+       * in the filter graph. The array containing the data can safely be reused
+       * immediately after this method returns.
+       *
+       * \param event the event coming from server with the associated data
+       */
+      void streamData(CEventServer& event);
+      bool isDataLate(void) ;
+      bool isEOF() {return isEOF_ ;}
+      bool sendReadDataRequest(const CDate& tsDataRequested) ;
+      CDataPacketPtr virtual apply(std::vector<CDataPacketPtr> data);
+      bool sendReadDataRequestIfNeeded(void) ;
+      void checkForLateData(void) ;
+
+     private:
+      
+      CDuration freqOp_ ;
+      CDuration offset_ ;
+      CDate lastDateReceived_ ;
+      bool isFirstDataSent_ = false ;
+
+      CField* field_;
+      shared_ptr<CGridRedistributeFilterIn> redistributeFilter_ ;
+      std::shared_ptr<CFileReaderSourceFilter> fileReaderSourceFilter_ ; 
+
+      bool isEOF_ = false ;
+      CDate dateEOF_ ;
+  }; // class CClientFromServerSourceFilter
+} // namespace xios
+
+#endif // __XIOS_CLIENT_ONLINE_READER_FILTER__
Index: XIOS3/trunk/src/filter/client_online_writer_filter.cpp
===================================================================
--- XIOS3/trunk/src/filter/client_online_writer_filter.cpp	(revision 2507)
+++ XIOS3/trunk/src/filter/client_online_writer_filter.cpp	(revision 2507)
@@ -0,0 +1,32 @@
+#include "context.hpp"
+
+#include "grid_redistribute_filter.hpp"
+#include "client_online_writer_filter.hpp"
+#include "field.hpp"
+#include "file.hpp"
+
+
+namespace xios
+{
+
+
+CClientOnlineWriterFilter::CClientOnlineWriterFilter(CGarbageCollector& gc, CField* field)
+    : CFilter(gc, 1, this)
+  {
+    CField* fieldOut ;
+    redistributeFilter_ = std::shared_ptr<CGridRedistributeFilter>(new CGridRedistributeFilter(gc, field, fieldOut));
+    fieldOut->setFileOut(field->getFileOut());
+    field->getFileOut()->replaceEnabledFields(field, fieldOut) ;
+    fieldOut->solveServerOperation() ; // might not be called, create a new time functor.... find a better solution later
+    
+    fileWriterStoreFilter_ = std::shared_ptr<CFileWriterStoreFilter>(new CFileWriterStoreFilter(gc, fieldOut));
+    redistributeFilter_->connectOutput(fileWriterStoreFilter_, 0);
+    connectOutput(redistributeFilter_,1) ;
+  }
+  
+  CDataPacketPtr CClientOnlineWriterFilter::apply(std::vector<CDataPacketPtr> data)
+  {
+    return data[0];
+  }
+
+}
Index: XIOS3/trunk/src/filter/client_online_writer_filter.hpp
===================================================================
--- XIOS3/trunk/src/filter/client_online_writer_filter.hpp	(revision 2507)
+++ XIOS3/trunk/src/filter/client_online_writer_filter.hpp	(revision 2507)
@@ -0,0 +1,40 @@
+#ifndef __XIOS_CLIENT_ONLINE_WRITER_FILTER__
+#define __XIOS_CLIENT_ONLINE_WRITER_FILTER__
+
+#include <map>
+
+#include "output_pin.hpp"
+#include "event_server.hpp"
+#include "context_client.hpp"
+#include "calendar_util.hpp"
+
+
+namespace xios
+{
+  class CGrid;
+  class CField;
+  class CGridRedistributeFilter ;
+  class CFileWriterStoreFilter ;
+
+  /*!
+   * A source filter is the entry point of the data in the graph of filters.
+   */
+  class CClientOnlineWriterFilter : public CFilter, public IFilterEngine
+  {
+    public:
+      /*!
+       * Constructs a source filter accepting data attached to the specified grid.
+       *
+       * \param gc the garbage collector associated with this filter
+       * \param field associated to the filter
+       */
+      CClientOnlineWriterFilter(CGarbageCollector& gc, CField* field);
+      CDataPacketPtr apply(std::vector<CDataPacketPtr> data) ;
+     private:
+
+      std::shared_ptr<CGridRedistributeFilter> redistributeFilter_ ;
+      std::shared_ptr<CFileWriterStoreFilter> fileWriterStoreFilter_ ; 
+  }; // class CClientFromServerSourceFilter
+} // namespace xios
+
+#endif // __XIOS_ONLINE_WRITER_FILTER__
Index: XIOS3/trunk/src/filter/file_writer_store_filter.cpp
===================================================================
--- XIOS3/trunk/src/filter/file_writer_store_filter.cpp	(revision 2498)
+++ XIOS3/trunk/src/filter/file_writer_store_filter.cpp	(revision 2507)
@@ -29,4 +29,5 @@
     if (!field->prec.isEmpty() && field->prec == 2) hasRounding_ = true ;
     if (!field->default_value.isEmpty()) {hasDefaultValue_=true ; defaultValue_ = field->default_value ;}
+    context->registerFileToWrite(file_) ;
   }
 
Index: XIOS3/trunk/src/filter/grid_redistribute_filter.cpp
===================================================================
--- XIOS3/trunk/src/filter/grid_redistribute_filter.cpp	(revision 2507)
+++ XIOS3/trunk/src/filter/grid_redistribute_filter.cpp	(revision 2507)
@@ -0,0 +1,80 @@
+#include "grid_redistribute_filter.hpp"
+#include "workflow_graph.hpp"
+namespace xios
+{
+  
+  CGridRedistributeFilter::CGridRedistributeFilter(CGarbageCollector& gc, CField* fieldIn, CField* &fieldOut) 
+                                    : CFilter(gc, 1, this)
+  {
+    
+    CGrid* redistributedGrid = fieldIn->getGrid()->redistributeGridToWriter() ;
+    fieldOut = CField::create() ;
+    fieldOut->field_ref=fieldIn->getId();
+    fieldOut->solveRefInheritance() ;
+    fieldOut->grid_ref=redistributedGrid->getId();
+    fieldOut->domain_ref.reset();
+    fieldOut->axis_ref.reset();
+    fieldOut->scalar_ref.reset();
+    fieldOut-> solveGridReference() ;
+    fieldOut-> getGrid()-> solveElementsRefInheritance() ;
+    CGrid* newGrid ;
+    std::pair<std::shared_ptr<CFilter>, std::shared_ptr<CFilter> > filters = redistributedGrid->buildTransformationGraph(gc, false,  fieldIn->getGrid(), false, 0. , newGrid, false, fieldOut) ;
+    fieldOut -> setGrid(newGrid) ;
+    fieldOut -> grid_ref = fieldOut->getGrid()->getId() ; // for server 
+    fieldOut->getGrid()->checkElementsAttributes() ;
+    redistributeConnector_ = fieldOut->getGrid()->getRedistributeToWriterConnector(fieldIn->getGrid()) ;
+  }
+
+  CDataPacketPtr CGridRedistributeFilter::apply(std::vector<CDataPacketPtr> data)
+  {
+    // for now, no auxilliairy field
+    CDataPacketPtr packet(new CDataPacket);
+    packet->date = data[0]->date;
+    packet->timestamp = data[0]->timestamp;
+    packet->status = data[0]->status;
+
+    if (packet->status == CDataPacket::NO_ERROR) 
+    {
+      // buildWorkflowGraph(data, packet, algorithm_);
+      
+      redistributeConnector_->transfer(data[0]->data, packet->data);
+    }
+    return packet;
+  }
+/*
+  void CTransformFilter::buildWorkflowGraph(std::vector<CDataPacketPtr> data, CDataPacketPtr packet, shared_ptr<CGridAlgorithm> algorithm)
+  {
+    if(this->graphEnabled)
+    {
+      this->graphPackage->filterId = CWorkflowGraph::getNodeSize();
+    
+      packet->graphPackage = new CGraphDataPackage;
+      if(data[0]->graphPackage)
+      {
+        packet->graphPackage->fromFilter = data[0]->graphPackage->fromFilter;
+      }
+      packet->graphPackage->toFilter = data[0]->graphPackage->toFilter;
+      packet->graphPackage->current_filter_name = data[0]->graphPackage->current_filter_name;
+      packet->graphPackage->contextId = data[0]->graphPackage->contextId;          
+    
+      int tmp_from = packet->graphPackage->fromFilter;
+      if(this->graphPackage->show)
+      {
+        packet->graphPackage->currentField = this->graphPackage->inFields[0];
+        CWorkflowGraph::addNode("Spatial transform filter "+algorithm->getAlgoName(), 4, false, 1, packet);
+        CWorkflowGraph::addEdge(packet->graphPackage->fromFilter, this->graphPackage->filterId, packet);
+        packet->graphPackage->fromFilter = this->graphPackage->filterId;
+        packet->graphPackage->currentField = this->graphPackage->inFields[0];
+        std::rotate(this->graphPackage->inFields.begin(), this->graphPackage->inFields.begin() + 1, this->graphPackage->inFields.end());
+      }
+      else
+      {
+        packet->graphPackage->currentField = this->graphPackage->inFields[0];
+        if(CXios::isClient) CWorkflowGraph::vectorOfNodes_->at(tmp_from).filter_name += algorithm->getAlgoName();
+        else                CWorkflowGraph::vectorOfNodes_srv_->at(tmp_from).filter_name += algorithm->getAlgoName();
+        
+      }     
+    }
+  }
+*/
+}
Index: XIOS3/trunk/src/filter/grid_redistribute_filter.hpp
===================================================================
--- XIOS3/trunk/src/filter/grid_redistribute_filter.hpp	(revision 2507)
+++ XIOS3/trunk/src/filter/grid_redistribute_filter.hpp	(revision 2507)
@@ -0,0 +1,33 @@
+#ifndef __XIOS_GRID_REDISTRIBUTE_FILTER_HPP__
+#define __XIOS_GRID_REDISTRIBUTE_FILTER_HPP__
+
+#include "filter.hpp"
+
+namespace xios
+{
+  
+  class CGridTransformConnector ;
+  /*!
+   * A filter to redistribute data from source grid to destination grid.
+   */
+    class CGridRedistributeFilter : public CFilter, IFilterEngine
+  {
+    public:
+
+      CGridRedistributeFilter(CGarbageCollector& gc, CField* fieldIn, CField* &fieldOut) ;
+
+    protected:
+      /*!
+        Overriding this function to process transformations with auxillary inputs
+      */
+      CDataPacketPtr virtual apply(std::vector<CDataPacketPtr> data) ;
+    
+    private:
+
+    shared_ptr<CGridTransformConnector> redistributeConnector_ ;
+  }; // class CTransformFilter
+
+
+} // namespace xios
+
+#endif //__XIOS_CSpatialTransformFilter__
Index: XIOS3/trunk/src/filter/grid_redistribute_filter_in.cpp
===================================================================
--- XIOS3/trunk/src/filter/grid_redistribute_filter_in.cpp	(revision 2507)
+++ XIOS3/trunk/src/filter/grid_redistribute_filter_in.cpp	(revision 2507)
@@ -0,0 +1,81 @@
+#include "grid_redistribute_filter_in.hpp"
+#include "workflow_graph.hpp"
+namespace xios
+{
+  
+  CGridRedistributeFilterIn::CGridRedistributeFilterIn(CGarbageCollector& gc, CField* fieldIn, CField* &fieldOut) 
+                                    : CFilter(gc, 1, this)
+  {
+    CGrid* redistributedGrid = fieldIn->getGrid()->redistributeGridToWriter() ;
+    fieldOut = CField::create() ;
+    fieldOut->field_ref=fieldIn->getId();
+    fieldOut->solveRefInheritance() ;
+    fieldOut->grid_ref=redistributedGrid->getId();
+    fieldOut->domain_ref.reset();
+    fieldOut->axis_ref.reset();
+    fieldOut->scalar_ref.reset();
+    fieldOut-> solveGridReference() ;
+    fieldOut-> getGrid()-> solveElementsRefInheritance() ;
+    CGrid* newGrid ;
+    std::pair<std::shared_ptr<CFilter>, std::shared_ptr<CFilter> > filters = redistributedGrid->buildTransformationGraph(gc, false,  fieldIn->getGrid(), false, 0. , newGrid, false, fieldOut) ;
+    fieldOut -> setGrid(newGrid) ;
+    fieldOut -> grid_ref = fieldOut->getGrid()->getId() ; // for server 
+    fieldOut->getGrid()->checkElementsAttributes() ;
+
+    redistributeConnector_ = fieldIn->getGrid()->getRedistributeToWriterConnector(fieldOut->getGrid()) ;    
+
+  }
+
+  CDataPacketPtr CGridRedistributeFilterIn::apply(std::vector<CDataPacketPtr> data)
+  {
+    // for now, no auxilliairy field
+    CDataPacketPtr packet(new CDataPacket);
+    packet->date = data[0]->date;
+    packet->timestamp = data[0]->timestamp;
+    packet->status = data[0]->status;
+
+    if (packet->status == CDataPacket::NO_ERROR) 
+    {
+      // buildWorkflowGraph(data, packet, algorithm_);
+      
+      redistributeConnector_->transfer(data[0]->data, packet->data);
+    }
+    return packet;
+  }
+/*
+  void CTransformFilter::buildWorkflowGraph(std::vector<CDataPacketPtr> data, CDataPacketPtr packet, shared_ptr<CGridAlgorithm> algorithm)
+  {
+    if(this->graphEnabled)
+    {
+      this->graphPackage->filterId = CWorkflowGraph::getNodeSize();
+    
+      packet->graphPackage = new CGraphDataPackage;
+      if(data[0]->graphPackage)
+      {
+        packet->graphPackage->fromFilter = data[0]->graphPackage->fromFilter;
+      }
+      packet->graphPackage->toFilter = data[0]->graphPackage->toFilter;
+      packet->graphPackage->current_filter_name = data[0]->graphPackage->current_filter_name;
+      packet->graphPackage->contextId = data[0]->graphPackage->contextId;          
+    
+      int tmp_from = packet->graphPackage->fromFilter;
+      if(this->graphPackage->show)
+      {
+        packet->graphPackage->currentField = this->graphPackage->inFields[0];
+        CWorkflowGraph::addNode("Spatial transform filter "+algorithm->getAlgoName(), 4, false, 1, packet);
+        CWorkflowGraph::addEdge(packet->graphPackage->fromFilter, this->graphPackage->filterId, packet);
+        packet->graphPackage->fromFilter = this->graphPackage->filterId;
+        packet->graphPackage->currentField = this->graphPackage->inFields[0];
+        std::rotate(this->graphPackage->inFields.begin(), this->graphPackage->inFields.begin() + 1, this->graphPackage->inFields.end());
+      }
+      else
+      {
+        packet->graphPackage->currentField = this->graphPackage->inFields[0];
+        if(CXios::isClient) CWorkflowGraph::vectorOfNodes_->at(tmp_from).filter_name += algorithm->getAlgoName();
+        else                CWorkflowGraph::vectorOfNodes_srv_->at(tmp_from).filter_name += algorithm->getAlgoName();
+        
+      }     
+    }
+  }
+*/
+}
Index: XIOS3/trunk/src/filter/grid_redistribute_filter_in.hpp
===================================================================
--- XIOS3/trunk/src/filter/grid_redistribute_filter_in.hpp	(revision 2507)
+++ XIOS3/trunk/src/filter/grid_redistribute_filter_in.hpp	(revision 2507)
@@ -0,0 +1,33 @@
+#ifndef __XIOS_GRID_REDISTRIBUTE_FILTER_IN_HPP__
+#define __XIOS_GRID_REDISTRIBUTE_FILTER_IN_HPP__
+
+#include "filter.hpp"
+
+namespace xios
+{
+  
+  class CGridTransformConnector ;
+  /*!
+   * A filter to redistribute data from source grid to destination grid.
+   */
+    class CGridRedistributeFilterIn : public CFilter, IFilterEngine
+  {
+    public:
+
+      CGridRedistributeFilterIn(CGarbageCollector& gc, CField* fieldOut, CField* &fieldIn) ;
+
+    protected:
+      /*!
+        Overriding this function to process transformations with auxillary inputs
+      */
+      CDataPacketPtr virtual apply(std::vector<CDataPacketPtr> data) ;
+    
+    private:
+
+    shared_ptr<CGridTransformConnector> redistributeConnector_ ;
+  }; // class CTransformFilter
+
+
+} // namespace xios
+
+#endif //__XIOS_GRID_REDISTRIBUTE_FILTER_IN_HPP__
Index: XIOS3/trunk/src/filter/output_pin.hpp
===================================================================
--- XIOS3/trunk/src/filter/output_pin.hpp	(revision 2498)
+++ XIOS3/trunk/src/filter/output_pin.hpp	(revision 2507)
@@ -30,5 +30,5 @@
        * \param inputSlot the input slot number
        */
-      void connectOutput(std::shared_ptr<CInputPin> inputPin, size_t inputSlot);
+      void virtual connectOutput(std::shared_ptr<CInputPin> inputPin, size_t inputSlot);
 
       /*!
Index: XIOS3/trunk/src/generate_fortran_interface.cpp
===================================================================
--- XIOS3/trunk/src/generate_fortran_interface.cpp	(revision 2498)
+++ XIOS3/trunk/src/generate_fortran_interface.cpp	(revision 2507)
@@ -53,4 +53,8 @@
   CDuplicateScalarToAxis duplicateScalarToAxis;
   CReduceScalarToScalar reduceScalarToScalar;
+
+  CRedistributeDomain redistributeDomain ;
+  CRedistributeAxis   redistributeAxis ;
+  CRedistributeScalar redistributeScalar ;
   
   ostringstream oss;
@@ -329,4 +333,8 @@
   file.open((path+"ireorder_domain_attr.F90").c_str());
   reorderDomain.generateFortranInterface(file);
+  file.close();
+
+  file.open((path+"iredistribute_domain_attr.F90").c_str());
+  redistributeDomain.generateFortranInterface(file);
   file.close();
   
@@ -435,4 +443,9 @@
   duplicateScalarToAxis.generateFortranInterface(file);
   file.close();
+
+  file.open((path+"iredistribute_axis_attr.F90").c_str());
+  redistributeAxis.generateFortranInterface(file);
+  file.close();
+
   /*!
     Scalar transformations
@@ -488,4 +501,7 @@
   file.close();
 
+  file.open((path+"iredistribute_scalar_attr.F90").c_str());
+  redistributeScalar.generateFortranInterface(file);
+  file.close();
 
 
Index: XIOS3/trunk/src/group_factory_decl.cpp
===================================================================
--- XIOS3/trunk/src/group_factory_decl.cpp	(revision 2498)
+++ XIOS3/trunk/src/group_factory_decl.cpp	(revision 2507)
@@ -50,4 +50,7 @@
   macro(CPoolNodeGroup)
   macro(CServiceNodeGroup)
+  macro(CRedistributeDomainGroup)
+  macro(CRedistributeAxisGroup)
+  macro(CRedistributeScalarGroup)
 
 }
Index: XIOS3/trunk/src/group_template_decl.cpp
===================================================================
--- XIOS3/trunk/src/group_template_decl.cpp	(revision 2498)
+++ XIOS3/trunk/src/group_template_decl.cpp	(revision 2507)
@@ -39,4 +39,7 @@
   macro(PoolNode)
   macro(ServiceNode)
+  macro(RedistributeDomain)
+  macro(RedistributeAxis)
+  macro(RedistributeScalar)
 
 }
Index: XIOS3/trunk/src/io/nc4_data_input.cpp
===================================================================
--- XIOS3/trunk/src/io/nc4_data_input.cpp	(revision 2498)
+++ XIOS3/trunk/src/io/nc4_data_input.cpp	(revision 2507)
@@ -81,9 +81,9 @@
             if ((domain->type) != CDomain::type_attr::unstructured)
             {
-              start.push_back(domain->jbegin);
-              count.push_back(domain->nj);
+              start.push_back(domain->jbeginValue_);
+              count.push_back(domain->njValue_);
             }
-            start.push_back(domain->ibegin);
-            count.push_back(domain->ni);
+            start.push_back(domain->ibeginValue_);
+            count.push_back(domain->niValue_);
             --idxDomain;
           }
@@ -131,5 +131,5 @@
     // Verify the compatibility of dimension of declared grid and real grid in file
     int realGridDim = 1;
-    bool isUnstructuredGrid = ((gridDim < 2) ? false :  SuperClassWriter::isUnstructured(fieldId));
+    bool isUnstructuredGrid = ((gridDim < 2 || domainP.size()==0) ? false :  SuperClassWriter::isUnstructured(fieldId));
     std::map<StdString, StdSize> dimSizeMap = SuperClassWriter::getDimensions(&fieldId);
     std::list<StdString> dimList = SuperClassWriter::getDimensionsList(&fieldId);
